routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::group(['prefix'=>'home','middleware'=>['auth']],function() {
    Route::get('/', 'HomeController@index')->name('home');
    Route::resource('/prescription','ResourceControllers\PrescriptionController');
    Route::resource('/ingridient','ResourceControllers\IngridientController');
    Route::post('/prescription/change',array('as' => 'prescription.change', 'uses' => 'ResourceControllers\PrescriptionController@change'));
    Route::get('prescription/{site}/delete', ['as' => 'prescription.delete', 'uses' => 'ResourceControllers\PrescriptionController@destroy']);
    Route::get('ingridient/{site}/delete', ['as' => 'ingridient.delete', 'uses' => 'ResourceControllers\IngridientController@destroy']);
    Route::get('/parse',array('as' => 'parse', 'uses' => 'HomeController@parse'));
});
Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

app/Prescription.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Prescription extends Model
{
    public function ingredients()
    {
        return $this->belongsToMany('App\Ingridient', 'ingridient_prescriptions')
            -> withPivot ( 'dimension_id', 'count' )
            -> withTimestamps ();
    }

    public function dimensions()
    {
        return $this->belongsToMany('App\Dimension', 'ingridient_prescriptions');
    }

    public function ingridient_prescriptions()
    {
        return $this->hasMany('App\Ingridient_Prescription');
    }
}

app/Http/Controllers/ResourceControllers/PrescriptionController.php
<?php

namespace App\Http\Controllers\ResourceControllers;

use App\Dimension;
use App\Ingridient_Prescription;
use App\Prescription;
use App\Ingridient;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class PrescriptionController extends Controller
{
    public function index()
    {
       return view('prescription.index', [
            'ingridients' => Prescription::all()
       ]);
    }

    public function create()
    {
        return view('prescription.create', [
            'prescriptions' => [],
            'ingridients_all' => Ingridient::all(),
            'dimensions_all' => Dimension::all(),
            'create' => true,
            'route' => 'prescription.store',
            'method' => 'post',
            'h1' => 'Добавление рецепта'
        ]);
    }

    public function store(Request $request)
    {
        $this->validate($request, [
            'name' => 'required',
            'description' => 'required',
        ]);
        $prescription = new Prescription;
        $prescription->name = $request->name;
        $prescription->description = $request->description;;
        $prescription->save();
        foreach ($request->dimension as $key => $val ) {
            $ingridient = Ingridient::find($request->ingridients[$key]);
            $array = [
                'dimension_id' => $val,
                'count' => $request->count[$key]
            ];
            $ingridient->prescriptions()->attach($prescription,$array);
        }
        return redirect('home/prescription/')->with('success', 'Рецепт успешно добавлен!');
    }

    public function show($id)
    {
      return view('prescription.show', [
          'prescriptions' => Prescription::find($id),
          'ingridients' => Prescription::find($id)->ingredients()->orderBy('ingridient_prescriptions.ingridient_id')->get(),
          'dimensions' => Prescription::find($id)->dimensions()->orderBy('ingridient_prescriptions.ingridient_id')->get(),
          'ingridient_prescription_count' => Ingridient_Prescription::prescription_Id($id)->orderBy('ingridient_prescriptions.ingridient_id')->get(),
      ]);
    }

    public function edit($id)
    {
        return view('prescription.create', [
            'prescriptions' => Prescription::find($id),
            'ingridients' => Prescription::find($id)->ingredients()->orderBy('ingridient_prescriptions.ingridient_id')->get(),
            'ingridients_all' => Ingridient::all(),
            'dimensions' => Prescription::find($id)->dimensions()->orderBy('ingridient_prescriptions.ingridient_id')->get(),
            'dimensions_all' => Dimension::all(),
            'counts' => Prescription::find($id)->ingridient_prescriptions()->orderBy('ingridient_prescriptions.ingridient_id')->get(),
            'create' => false,
            'route' => 'prescription.update',
            'method' => 'PUT',
            'h1' => 'Редактирование рецепта'
        ]);
    }

    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'name' => 'required',
            'description' => 'required',
            'ingridients' => 'required'
        ]);
        $prescription = Prescription::find($id);
        $prescription->name = $request->input('name');
        $prescription->description = $request->input('description');
        $prescription->save();
        foreach ($request->ingridients as $key => $val) {
            $array[$val] = [
                'dimension_id' => $request->dimension[$key],
                'count' => $request->count[$key]
            ];
        }
        $prescription->ingredients()->sync($array);
        return redirect('home/prescription')
            ->with('success', 'Рецепт успешно изменен!');
    }

    public function destroy($id)
    {
        $precription = Prescription::find($id);
        $precription->delete();
        return redirect('home/prescription')
            ->with('success', 'Рецепт успешно удален!');
    }

    public function change(Request $request)
    {
        Ingridient_Prescription::where([
            ['prescription_id', $request->prescription_id],
            ['ingridient_id', $request->ingredient_id]
        ])
            ->update([
                'count' => $request->count_data
            ]);
    }
}

resources/views/prescription/partials/form.blade.php
<label class="">Название</label>
<input type="text" class="form-control" name="name" value="{{$prescriptions->name or ""}}">
<label>Описание</label>
<input type="text" class="form-control" name="description" value="{{$prescriptions->description or ""}}">
<hr>

<div class="w-100 p-3 d-block float-right" name="div_ingridients">

    <div id='form_left' class='col-xs-6' >
    <label class="mr-5">Ингридиент</label> <label class='ml-5'>Количество</label><br>
    <?php
        if(!$create) {
            foreach ($ingridients as $key=>$ingridient) {
                echo "<div id='div-".$ingridient->id."'><select class='mb-2 mr-2 sBig'  name='ingridients[]'>";
                foreach ($ingridients_all as $ing) {
                    echo " <option ";
                    if ($ingridient->name==$ing->name) {
                        echo "selected " ;
                    } else {
                        foreach ($ingridients as $ing_dis) {
                            if ($ing_dis->name==$ing->name) {
                                echo " disabled ";
                              }
                        }
                    }
                    echo "value='".$ing->id ."'>".$ing->name."</option>";
                }
                echo "</select>";
                echo "<input class='mt-1 ml-2' style='height:28px;' name='count[]' value='".$counts[$key]->count."'>
               <select class='mb-2 sSmall'  name='dimension[]'>";
                foreach ($dimensions_all as $dim_all) {
                    echo "<option value='".$dim_all->id."'";
                    if ($dimensions[$key]->name==$dim_all->name) {
                        echo"selected";
                    }
                    echo ">".$dim_all->name."</option>";
                }
                echo "</select>
                    <div class='btn btn-default mb-1' id='button-".$ingridient->id."' onclick='DeleteDynamicExtraField(this)'><i class='nav-icon fa fa-times'></i></div></br></div>";
            }
        } else {
            echo "<div> <select class='mr-1 mb-1 mt-1 sBig' name='ingridients[]'>";
                   foreach ($ingridients_all as $ing) {
                       echo " <option ";echo "value='".$ing->id ."'>".$ing->name."</option>";
                   }
                   echo "</select>
                        <input class='mt-1 ml-2 mr-1' style='height:28px;' name='count[]' value=''>
                        <select class='mb-2 mr-1 sSmall' name='dimension[]'>";
                        foreach ($dimensions_all as$dim_all) {
                            echo "<option value='".$dim_all->id."'>".$dim_all->name."</option>";
                        }
                        echo "</select>
                       <div class='btn btn-default mb-1 mr-2 ml-1' onclick='DeleteDynamicExtraField(this)'><i class='nav-icon fa fa-times'></i></div> </br>
                       </div></div>";
        }
        echo "</div>";
    ?>
<div class="w-100 p-3 d-block float-left d">
    <div class="col-xs-3 ">
         <div  class="btn btn-secondary  send" id="end_div" >Добавить</div>
    </div>
    <div class="col-xs-2 mt-2" style="width: 13%;">
        <p>Нет в списке?</p>
    </div>
    <div class="col-xs-2 " style="display: inline-block">
        <a href="#myModal1" class="btn btn-secondary " data-toggle="modal">Создать новый ингредиент</a>
    </div>
</div>
    <div class="w-100 p-3 d-block float-left">
        <div class="col-xs-4 d-inline-block">
            <input class="btn btn-primary btn-lg height-control" type="submit" value="Сохранить рецепт">
        </div>
    </div>
</div >
<script>

    function DeleteDynamicExtraField(element){
        $(element).parent().remove();
    }

    window.onload = function() {
        $('.sBig').select2({width:'125px'});
        $('.sSmall').select2({width:'55px'});
        var button = document.getElementById("end_div");
        var new_ing_create = document.getElementById("new_ing_create");
        var elem_left = document.getElementById("form_left");
        var modal = document.getElementById('myModal1');
        var button_close = document.getElementById("btn_close");
        button.addEventListener("mousedown", function (event) {
            var div = $('<div/>', {
                'class': 'DynamicExtraField',
                'id': "DynamicField",
            }).appendTo(elem_left);
            var select_ing = $('<select/>', {
                'class': 'mr-1 mb-1 mt-1',
                'name' : 'ingridients[]'
            }).html('@foreach($ingridients_all as $ingridient)\n' +
                '<option value="{{$ingridient->id}}">{{$ingridient->name}}</option>\n' +
                '@endforeach') .appendTo(div).prop('required', true);
            $(select_ing).select2({ width: '125px' });
            var select_dim = $('<input/>', {
                'class': 'mt-1 ml-2 mr-2',
                'style':'height:28px;',
                'name' : 'count[]'
            }).appendTo(div).prop('required', true);
            var select_dim = $('<select/>', {
                'class': 'mb-2 mr-1',
                'name' : 'dimension[]'
            }).html('@foreach($dimensions_all as $dimension)\n' +
                '<option value="{{$dimension->id}}">{{$dimension->name}}</option>\n' +
                '@endforeach') .appendTo(div).prop('required', true);
            $(select_dim).select2({ width: '55px' });
            var select_dim_but = $('<div/>', {
                'class': 'btn btn-default  mb-1 mr-2 ml-2',
                'name' : 'delete[]',
                'onclick':'ingredient_new_detach()'
            }).html('<i class="nav-icon fa fa-times"></i>\n').appendTo(div).prop('required', true);
            select_dim_but.click(function() {
                $(this).parent().remove();
            });
        });
        new_ing_create.addEventListener("mousedown", function (event) {
            var ingredient = $('#name_ing').val();
            $.ajaxSetup({
                beforeSend: function(xhr, type) {
                    if (!type.crossDomain) {
                        xhr.setRequestHeader('X-CSRF-Token', $('meta[name="csrf-token"]').attr('content'));
                    }
                },
            });
            $.ajax({
                type: 'POST',
                url: '{{route('ingridient.store')}}',
                data: {name_ingredient:ingredient},
                success:function(result){
                    jQuery.noConflict()
                    $('#myModal1').modal('hide');
                    modal.style.display = "none";
                }
            });
        });
        window.onclick = function(event) {
            if ((event.target == modal)||(event.target ==button_close)) {
                modal.style.display = "none";
                jQuery.noConflict()
                $('#myModal1').modal('hide');
            }
        }
    }
</script>